unit SearchBrowse;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, siis_api;

const
PLUGIN_ID=$0008;

type
  TSearchDialog = class(TForm)
    PageControl1: TPageControl;
    TabMain: TTabSheet;
    TabReadMe: TTabSheet;
    GroupBoxPagesInfo: TGroupBox;
    lblFName: TLabel;
    lblLName: TLabel;
    lblComments: TLabel;
    edtFName: TEdit;
    edtLName: TEdit;
    btnSearch: TButton;
    txtReadMe: TMemo;
    edtComments: TEdit;
    lvDocs: TListView;
    GroupBoxSort: TGroupBox;
    rbFName: TRadioButton;
    rbLName: TRadioButton;
    edtSQL: TEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure edtFNameChange(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure UpdateSQLSTring;
    procedure rbFNameClick(Sender: TObject);
    procedure lvDocsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

{var
  TreeDialog: TTreeDialog; }

implementation
// include functions prototypes
// ============================
{$INCLUDE ..\common\siis_prototypes.inc}

{$R *.DFM}


procedure TSearchDialog.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action := caFree;
end;

procedure TSearchDialog.edtFNameChange(Sender: TObject);
begin
if ((Length(edtFName.Text)> 0) or
    (Length(edtLName.Text)> 0) or
    (Length(edtComments.Text)> 0) ) then
     btnSearch.Enabled:=TRUE
   else
    btnSearch.Enabled:=FALSE;
UpdateSQLString;
end;

procedure TSearchDialog.btnSearchClick(Sender: TObject);
Var
 DocSearch:TCustomDocumentSearch;
 DocInfo:TDocumentInfo;
 i:Integer;
 szFName, szLName:array[0..32] of char;

 // you must have the built-in buffers allocated even if you don't use them
 // ========================================================================
 szName, szDesc, szKwd:array[0..255] of char;
 szDate:array[0..32] of char;

 szComments:array[0..4096] of char;
 LI:TListItem;
begin
 DocSearch.szSQLStmt:=PChar(edtSQL.Text);
 ssxDocumentCustomSearch(@DocSearch);
 lvDocs.Items.Clear;
 for i:=0 to DocSearch.iRecordsFound-1 do
  begin
   DocInfo.iPos:=i+1; // travering functions starts at 1
   DocInfo.szName:=@szName;
   DocInfo.szDescription:=@szDesc;
   DocInfo.szKeywords:=@szKwd;
   DocInfo.szDate:=@szDate;

   DocInfo.iNF:=3;
   DocInfo.szCFN[0]:=PChar('FName');
   DocInfo.szCFN[1]:=PChar('LName');
   DocInfo.szCFN[2]:=PChar('Comments');
   DocInfo.szCFV[0] := @szFName[0];
   DocInfo.szCFV[1] := @szLName[0];
   DocInfo.szCFV[2] := @szComments[0];
   ssxGetDocumentCustomSearchInfo(@DocInfo);
   LI:=lvDocs.Items.Add;
   LI.Caption:=IntToStr(DocInfo.iDocumentID);
   LI.SubItems.Add(StrPas(szFName)); // we passed the pointer same as szCFV[0]
   LI.SubItems.Add(StrPAs(szLName)); // we passed the pointer same as szCFV[1]
   LI.SubItems.Add(StrPas(szComments)); // we passed the pointer same as szCFV[2]

  end;
end;


procedure TSearchDialog.UpdateSQLSTring;
Var
szSQL:String;
begin
 szSQL:='';

 // First Name
 if Trim(edtFName.Text)<>'' then
  szSQL:=' FName like '+ QuotedStr(edtFName.Text+'%' );

  // Last Name
 if Trim(edtLName.Text)<>'' then
  szSQL:=szSQL + ' and LName like '+ QuotedStr(edtLName.Text+'%' );

 // Comments
 if Trim(edtComments.Text)<>'' then
  szSQL:=szSQL + ' and Comments like '+ QuotedStr('%'+edtComments.Text+'%' );

 // sort order
 if rbFName.Checked then
  szSQL := szSQL+' Order by FName';
 if rbLName.Checked then
  szSQL := szSQL+' Order by LName';

 // clean up SQL statement
 if Copy(szSQL, 1, 4)=' and' then
  szSQL := copy(szSQL, 5, 999);

 // update the debug field edtSQL
 edtSQL.Text:=szSQL;
end;

procedure TSearchDialog.rbFNameClick(Sender: TObject);
begin
UpdateSQLString;
end;

procedure TSearchDialog.lvDocsClick(Sender: TObject);
Var
li:TListItem;
docID:Integer;
DocInfo:TDocumentInfo;
begin
li:=lvDocs.Selected;
if li=nil then exit;

//document id is the caption of li
docID := StrToInt(li.Caption);

// we have the Doc ID, show document
DocInfo.iDocumentID:=docID;
ssxShowDocument(@DocInfo);

end;

end.
